# all files / ol/format/ wfs.js

95.07% Statements 328/345
79.49% Branches 93/117
97.56% Functions 40/41
95.07% Lines 328/345

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344
    345
    346
    347
    348
    349
    350
    351
    352
    353
    354
    355
    356
    357
    358
    359
    360
    361
    362
    363
    364
    365
    366
    367
    368
    369
    370
    371
    372
    373
    374
    375
    376
    377
    378
    379
    380
    381
    382
    383
    384
    385
    386
    387
    388
    389
    390
    391
    392
    393
    394
    395
    396
    397
    398
    399
    400
    401
    402
    403
    404
    405
    406
    407
    408
    409
    410
    411
    412
    413
    414
    415
    416
    417
    418
    419
    420
    421
    422
    423
    424
    425
    426
    427
    428
    429
    430
    431
    432
    433
    434
    435
    436
    437
    438
    439
    440
    441
    442
    443
    444
    445
    446
    447
    448
    449
    450
    451
    452
    453
    454
    455
    456
    457
    458
    459
    460
    461
    462
    463
    464
    465
    466
    467
    468
    469
    470
    471
    472
    473
    474
    475
    476
    477
    478
    479
    480
    481
    482
    483
    484
    485
    486
    487
    488
    489
    490
    491
    492
    493
    494
    495
    496
    497
    498
    499
    500
    501
    502
    503
    504
    505
    506
    507
    508
    509
    510
    511
    512
    513
    514
    515
    516
    517
    518
    519
    520
    521
    522
    523
    524
    525
    526
    527
    528
    529
    530
    531
    532
    533
    534
    535
    536
    537
    538
    539
    540
    541
    542
    543
    544
    545
    546
    547
    548
    549
    550
    551
    552
    553
    554
    555
    556
    557
    558
    559
    560
    561
    562
    563
    564
    565
    566
    567
    568
    569
    570
    571
    572
    573
    574
    575
    576
    577
    578
    579
    580
    581
    582
    583
    584
    585
    586
    587
    588
    589
    590
    591
    592
    593
    594
    595
    596
    597
    598
    599
    600
    601
    602
    603
    604
    605
    606
    607
    608
    609
    610
    611
    612
    613
    614
    615
    616
    617
    618
    619
    620
    621
    622
    623
    624
    625
    626
    627
    628
    629
    630
    631
    632
    633
    634
    635
    636
    637
    638
    639
    640
    641
    642
    643
    644
    645
    646
    647
    648
    649
    650
    651
    652
    653
    654
    655
    656
    657
    658
    659
    660
    661
    662
    663
    664
    665
    666
    667
    668
    669
    670
    671
    672
    673
    674
    675
    676
    677
    678
    679
    680
    681
    682
    683
    684
    685
    686
    687
    688
    689
    690
    691
    692
    693
    694
    695
    696
    697
    698
    699
    700
    701
    702
    703
    704
    705
    706
    707
    708
    709
    710
    711
    712
    713
    714
    715
    716
    717
    718
    719
    720
    721
    722
    723
    724
    725
    726
    727
    728
    729
    730
    731
    732
    733
    734
    735
    736
    737
    738
    739
    740
    741
    742
    743
    744
    745
    746
    747
    748
    749
    750
    751
    752
    753
    754
    755
    756
    757
    758
    759
    760
    761
    762
    763
    764
    765
    766
    767
    768
    769
    770
    771
    772
    773
    774
    775
    776
    777
    778
    779
    780
    781
    782
    783
    784
    785
    786
    787
    788
    789
    790
    791
    792
    793
    794
    795
    796
    797
    798
    799
    800
    801
    802
    803
    804
    805
    806
    807
    808
    809
    810
    811
    812
    813
    814
    815
    816
    817
    818
    819
    820
    821
    822
    823
    824
    825
    826
    827
    828
    829
    830
    831
    832
    833
    834
    835
    836
    837
    838
    839
    840
    841
    842
    843
    844
    845
    846
    847
    848
    849
    850
    851
    852
    853
    854
    855
    856
    857
    858
    859
    860
    861
    862
    863
    864
    865
    866
    867
    868
    869
    870
    871
    872
    873
    874
    875
    876
    877
    878
    879
    880
    881
    882
    883
    884
    885
    886
    887
    888
    889
    890
    891
    892
    893
    894
    895
    896
    897
    898
    899
    900
    901
    902
    903
    904
    905
    906
    907
    908
    909
    910
    911
    912
    913
    914
    915
    916
    917
    918
    919
    920
    921
    922
    923
    924
    925
    926
    927
    928
    929
    930
    931
    932
    933
    934
    935
    936
    937
    938
    939
    940
    941
    942
    943
    944
    945
    946
    947
    948
    949
    950
    951
    952
    953
    954
    955
    956
    957
    958
    959
    960
    961
    962
    963
    964
    965
    966
    967
    968
    969
    970
    971
    972
    973
    974
    975
    976
    977
    978
    979
    980
    981
    982
    983
    984
    985
    986
    987
    988
    989
    990
    991
    992
    993
    994
    995
    996
    997
    998
    999
    1000
    1001
    1002
    1003
    1004
    1005
    1006
    1007
    1008
    1009
    1010
    1011
    1012
    1013
    1014
    1015
    1016
    1017
    1018
    1019
    1020
    1021
    1022
    1023
    1024
    1025
    1026
    1027
    1028
    1029
    1030
    1031
    1032
    1033
    1034
    1035
    1036
    1037
    1038
    1039
    1040
    1041
    1042
    1043
    1044
    1045
    1046
    1047
    1048
    1049
    1050
    1051
    1052
    1053
    1054
    1055
    1056
    1057
    1058
    1059
    1060
    1061
    1062
    1063
    1064
    1065
    1066
    1067
    1068
    1069
    10701×

    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×
    43×

    43×

    43×

    43×

    43×

    43×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×
    12×

    12×

    12×
    12×

    12×

    12×

    12×

    1×
    1×

    1×

    1×
    1×
    1×

    1×
    2×

    2×

    2×
    2×
    2×

    1×
    2×
    2×
    2×

    1×

    1×
    2×
    2×

    2×
    2×

    1×

    1×
    1×

    1×

    2×

    1×
    2×

    1×

    1×
    1×

    1×

    1×
    1×
    1×
    1×

    1×
    1×

    1×

    1×
    7×
    7×
    7×
    7×
    7×
    7×
    7×
    2×

    5×

    1×
    10×
    10×
    10×
    10×
    10×

    1×
    24×

    24×

    24×
    2×

    22×

    1×
    3×
    3×
    3×
    3×
    3×
    3×
    3×
    3×

    3×
    3×
    3×

    1×
    8×
    8×
    7×
    7×
    7×
    7×
    7×
    7×

    7×
    7×
    7×
    7×
    7×
    22×
    22×
    17×

    7×

    7×

    1×
    17×
    17×
    17×
    17×
    17×
    17×
    12×
    12×
    12×
    7×
    2×

    5×

    5×

    1×
    2×
    2×

    2×
    2×

    2×
    2×

    1×

    1×
    17×
    17×
    17×
    17×
    17×
    17×

    17×
    14×

    3×

    17×
    17×
    15×

    17×
    14×

    17×
    17×
    17×

    17×
    17×
    13×
    13×
    13×

    1×

    14×
    14×

    1×
    2×
    2×

    2×
    2×

    1×
    1×
    1×

    1×
    1×

    1×
    1×
    1×

    1×
    1×

    1×

    1×
    1×
    1×

    1×

    1×

    1×
    1×
    1×

    1×
    1×
    1×

    1×

    6×
    6×
    6×
    13×
    13×

    1×

    1×
    1×
    1×

    1×
    11×
    1×

    11×
    11×

    1×
    1×

    1×
    1×

    1×
    1×
    1×

    1×
    1×
    1×

    1×
    3×
    3×
    3×
    3×
    1×

    3×
    3×

    1×
    36×
    36×
    36×

    1×
    20×

    1×
    16×

    1×
    2×
    2×

    2×
    2×
    2×

    1×

    1×
    1×
    1×
    1×

    1×
    16×
    16×
    16×
    16×

    1×
    16×
    16×
    16×
    16×
    16×
    16×

    16×

    16×

    16×
    1×

    16×
    1×

    16×
    1×

    16×
    16×
    1×

    1×

    1×

    1×

    16×

    16×

    16×

    16×
    16×

    1×

    12×
    12×
    12×

    12×
    12×
    12×
    12×

    12×
    12×
    12×
    12×
    1×

    12×
    12×

    12×
    12×
    7×

    7×
    7×

    12×
    9×

    9×
    9×

    11×
    3×

    11×
    1×

    11×

    1×

    1×

    1×
    12×

    11×
    11×
    12×

    2×
    2×
    2×

    10×

     goog.provide('ol.format.WFS');

    goog.require('ol');
    goog.require('ol.asserts');
    goog.require('ol.format.GML2');
    goog.require('ol.format.GML3');
    goog.require('ol.format.GMLBase');
    goog.require('ol.format.filter');
    goog.require('ol.format.XMLFeature');
    goog.require('ol.format.XSD');
    goog.require('ol.geom.Geometry');
    goog.require('ol.obj');
    goog.require('ol.proj');
    goog.require('ol.xml');

    /**
     * @classdesc
     * Feature format for reading and writing data in the WFS format.
     * By default, supports WFS version 1.1.0. You can pass a GML format
     * as option if you want to read a WFS that contains GML2 (WFS 1.0.0).
     * Also see {@link ol.format.GMLBase} which is used by this format.
     *
     * @constructor
     * @param {olx.format.WFSOptions=} opt_options
     *     Optional configuration object.
     * @extends {ol.format.XMLFeature}
     * @api
     */
    ol.format.WFS = function(opt_options) {
      var options = opt_options ? opt_options : {};

      /**
       * @private
       * @type {Array.<string>|string|undefined}
       */
      this.featureType_ = options.featureType;

      /**
       * @private
       * @type {Object.<string, string>|string|undefined}
       */
      this.featureNS_ = options.featureNS;

      /**
       * @private
       * @type {ol.format.GMLBase}
       */
      this.gmlFormat_ = options.gmlFormat ?
        options.gmlFormat : new ol.format.GML3();

      /**
       * @private
       * @type {string}
       */
      this.schemaLocation_ = options.schemaLocation ?
        options.schemaLocation :
        ol.format.WFS.SCHEMA_LOCATIONS[ol.format.WFS.DEFAULT_VERSION];

      ol.format.XMLFeature.call(this);
    };
    ol.inherits(ol.format.WFS, ol.format.XMLFeature);

    /**
     * @const
     * @type {string}
     */
    ol.format.WFS.FEATURE_PREFIX = 'feature';

    /**
     * @const
     * @type {string}
     */
    ol.format.WFS.XMLNS = 'http://www.w3.org/2000/xmlns/';

    /**
     * @const
     * @type {string}
     */
    ol.format.WFS.OGCNS = 'http://www.opengis.net/ogc';

    /**
     * @const
     * @type {string}
     */
    ol.format.WFS.WFSNS = 'http://www.opengis.net/wfs';

    /**
     * @const
     * @type {string}
     */
    ol.format.WFS.FESNS = 'http://www.opengis.net/fes';

    /**
     * @const
     * @type {Object.<string, string>}
     */
    ol.format.WFS.SCHEMA_LOCATIONS = {
      '1.1.0': 'http://www.opengis.net/wfs ' +
          'http://schemas.opengis.net/wfs/1.1.0/wfs.xsd',
      '1.0.0': 'http://www.opengis.net/wfs ' +
          'http://schemas.opengis.net/wfs/1.0.0/wfs.xsd'
    };

    /**
     * @const
     * @type {string}
     */
    ol.format.WFS.DEFAULT_VERSION = '1.1.0';

    /**
     * Read all features from a WFS FeatureCollection.
     *
     * @function
     * @param {Document|Node|Object|string} source Source.
     * @param {olx.format.ReadOptions=} opt_options Read options.
     * @return {Array.<ol.Feature>} Features.
     * @api
     */
    ol.format.WFS.prototype.readFeatures;

    /**
     * @inheritDoc
     */
    ol.format.WFS.prototype.readFeaturesFromNode = function(node, opt_options) {
      var context = /** @type {ol.XmlNodeStackItem} */ ({
        'featureType': this.featureType_,
        'featureNS': this.featureNS_
      });
      ol.obj.assign(context, this.getReadOptions(node,
          opt_options ? opt_options : {}));
      var objectStack = [context];
      this.gmlFormat_.FEATURE_COLLECTION_PARSERS[ol.format.GMLBase.GMLNS][
          'featureMember'] =
          ol.xml.makeArrayPusher(ol.format.GMLBase.prototype.readFeaturesInternal);
      var features = ol.xml.pushParseAndPop([],
          this.gmlFormat_.FEATURE_COLLECTION_PARSERS, node,
          objectStack, this.gmlFormat_);
      Iif (!features) {
        features = [];
      }
      return features;
    };

    /**
     * Read transaction response of the source.
     *
     * @param {Document|Node|Object|string} source Source.
     * @return {ol.WFSTransactionResponse|undefined} Transaction response.
     * @api
     */
    ol.format.WFS.prototype.readTransactionResponse = function(source) {
      Iif (ol.xml.isDocument(source)) {
        return this.readTransactionResponseFromDocument(
            /** @type {Document} */ (source));
      } else Iif (ol.xml.isNode(source)) {
        return this.readTransactionResponseFromNode(/** @type {Node} */ (source));
      } else Eif (typeof source === 'string') {
        var doc = ol.xml.parse(source);
        return this.readTransactionResponseFromDocument(doc);
      } else {
        return undefined;
      }
    };

    /**
     * Read feature collection metadata of the source.
     *
     * @param {Document|Node|Object|string} source Source.
     * @return {ol.WFSFeatureCollectionMetadata|undefined}
     *     FeatureCollection metadata.
     * @api
     */
    ol.format.WFS.prototype.readFeatureCollectionMetadata = function(source) {
      Iif (ol.xml.isDocument(source)) {
        return this.readFeatureCollectionMetadataFromDocument(
            /** @type {Document} */ (source));
      } else Iif (ol.xml.isNode(source)) {
        return this.readFeatureCollectionMetadataFromNode(
            /** @type {Node} */ (source));
      } else Eif (typeof source === 'string') {
        var doc = ol.xml.parse(source);
        return this.readFeatureCollectionMetadataFromDocument(doc);
      } else {
        return undefined;
      }
    };

    /**
     * @param {Document} doc Document.
     * @return {ol.WFSFeatureCollectionMetadata|undefined}
     *     FeatureCollection metadata.
     */
    ol.format.WFS.prototype.readFeatureCollectionMetadataFromDocument = function(doc) {
      for (var n = doc.firstChild; n; n = n.nextSibling) {
        Eif (n.nodeType == Node.ELEMENT_NODE) {
          return this.readFeatureCollectionMetadataFromNode(n);
        }
      }
      return undefined;
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.WFS.FEATURE_COLLECTION_PARSERS_ = {
      'http://www.opengis.net/gml': {
        'boundedBy': ol.xml.makeObjectPropertySetter(
            ol.format.GMLBase.prototype.readGeometryElement, 'bounds')
      }
    };

    /**
     * @param {Node} node Node.
     * @return {ol.WFSFeatureCollectionMetadata|undefined}
     *     FeatureCollection metadata.
     */
    ol.format.WFS.prototype.readFeatureCollectionMetadataFromNode = function(node) {
      var result = {};
      var value = ol.format.XSD.readNonNegativeIntegerString(
          node.getAttribute('numberOfFeatures'));
      result['numberOfFeatures'] = value;
      return ol.xml.pushParseAndPop(
          /** @type {ol.WFSFeatureCollectionMetadata} */ (result),
          ol.format.WFS.FEATURE_COLLECTION_PARSERS_, node, [], this.gmlFormat_);
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.WFS.TRANSACTION_SUMMARY_PARSERS_ = {
      'http://www.opengis.net/wfs': {
        'totalInserted': ol.xml.makeObjectPropertySetter(
            ol.format.XSD.readNonNegativeInteger),
        'totalUpdated': ol.xml.makeObjectPropertySetter(
            ol.format.XSD.readNonNegativeInteger),
        'totalDeleted': ol.xml.makeObjectPropertySetter(
            ol.format.XSD.readNonNegativeInteger)
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @return {Object|undefined} Transaction Summary.
     * @private
     */
    ol.format.WFS.readTransactionSummary_ = function(node, objectStack) {
      return ol.xml.pushParseAndPop(
          {}, ol.format.WFS.TRANSACTION_SUMMARY_PARSERS_, node, objectStack);
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.WFS.OGC_FID_PARSERS_ = {
      'http://www.opengis.net/ogc': {
        'FeatureId': ol.xml.makeArrayPusher(function(node, objectStack) {
          return node.getAttribute('fid');
        })
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @private
     */
    ol.format.WFS.fidParser_ = function(node, objectStack) {
      ol.xml.parseNode(ol.format.WFS.OGC_FID_PARSERS_, node, objectStack);
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.WFS.INSERT_RESULTS_PARSERS_ = {
      'http://www.opengis.net/wfs': {
        'Feature': ol.format.WFS.fidParser_
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<*>} objectStack Object stack.
     * @return {Array.<string>|undefined} Insert results.
     * @private
     */
    ol.format.WFS.readInsertResults_ = function(node, objectStack) {
      return ol.xml.pushParseAndPop(
          [], ol.format.WFS.INSERT_RESULTS_PARSERS_, node, objectStack);
    };

    /**
     * @const
     * @type {Object.<string, Object.<string, ol.XmlParser>>}
     * @private
     */
    ol.format.WFS.TRANSACTION_RESPONSE_PARSERS_ = {
      'http://www.opengis.net/wfs': {
        'TransactionSummary': ol.xml.makeObjectPropertySetter(
            ol.format.WFS.readTransactionSummary_, 'transactionSummary'),
        'InsertResults': ol.xml.makeObjectPropertySetter(
            ol.format.WFS.readInsertResults_, 'insertIds')
      }
    };

    /**
     * @param {Document} doc Document.
     * @return {ol.WFSTransactionResponse|undefined} Transaction response.
     */
    ol.format.WFS.prototype.readTransactionResponseFromDocument = function(doc) {
      for (var n = doc.firstChild; n; n = n.nextSibling) {
        Eif (n.nodeType == Node.ELEMENT_NODE) {
          return this.readTransactionResponseFromNode(n);
        }
      }
      return undefined;
    };

    /**
     * @param {Node} node Node.
     * @return {ol.WFSTransactionResponse|undefined} Transaction response.
     */
    ol.format.WFS.prototype.readTransactionResponseFromNode = function(node) {
      return ol.xml.pushParseAndPop(
          /** @type {ol.WFSTransactionResponse} */({}),
          ol.format.WFS.TRANSACTION_RESPONSE_PARSERS_, node, []);
    };

    /**
     * @type {Object.<string, Object.<string, ol.XmlSerializer>>}
     * @private
     */
    ol.format.WFS.QUERY_SERIALIZERS_ = {
      'http://www.opengis.net/wfs': {
        'PropertyName': ol.xml.makeChildAppender(ol.format.XSD.writeStringTextNode)
      }
    };

    /**
     * @param {Node} node Node.
     * @param {ol.Feature} feature Feature.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeFeature_ = function(node, feature, objectStack) {
      var context = objectStack[objectStack.length - 1];
      var featureType = context['featureType'];
      var featureNS = context['featureNS'];
      var gmlVersion = context['gmlVersion'];
      var child = ol.xml.createElementNS(featureNS, featureType);
      node.appendChild(child);
      if (gmlVersion === 2) {
        ol.format.GML2.prototype.writeFeatureElement(child, feature, objectStack);
      } else {
        ol.format.GML3.prototype.writeFeatureElement(child, feature, objectStack);
      }
    };

    /**
     * @param {Node} node Node.
     * @param {number|string} fid Feature identifier.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeOgcFidFilter_ = function(node, fid, objectStack) {
      var filter = ol.xml.createElementNS(ol.format.WFS.OGCNS, 'Filter');
      var child = ol.xml.createElementNS(ol.format.WFS.OGCNS, 'FeatureId');
      filter.appendChild(child);
      child.setAttribute('fid', fid);
      node.appendChild(filter);
    };

    /**
     * @param {string|undefined} featurePrefix The prefix of the feature.
     * @param {string} featureType The type of the feature.
     * @returns {string} The value of the typeName property.
     * @private
     */
    ol.format.WFS.getTypeName_ = function(featurePrefix, featureType) {
      featurePrefix = featurePrefix ? featurePrefix :
        ol.format.WFS.FEATURE_PREFIX;
      var prefix = featurePrefix + ':';
      // The featureType already contains the prefix.
      if (featureType.indexOf(prefix) === 0) {
        return featureType;
      } else {
        return prefix + featureType;
      }
    };

    /**
     * @param {Node} node Node.
     * @param {ol.Feature} feature Feature.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeDelete_ = function(node, feature, objectStack) {
      var context = objectStack[objectStack.length - 1];
      ol.asserts.assert(feature.getId() !== undefined, 26); // Features must have an id set
      var featureType = context['featureType'];
      var featurePrefix = context['featurePrefix'];
      var featureNS = context['featureNS'];
      var typeName = ol.format.WFS.getTypeName_(featurePrefix, featureType);
      node.setAttribute('typeName', typeName);
      ol.xml.setAttributeNS(node, ol.format.WFS.XMLNS, 'xmlns:' + featurePrefix,
          featureNS);
      var fid = feature.getId();
      Eif (fid !== undefined) {
        ol.format.WFS.writeOgcFidFilter_(node, fid, objectStack);
      }
    };

    /**
     * @param {Node} node Node.
     * @param {ol.Feature} feature Feature.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeUpdate_ = function(node, feature, objectStack) {
      var context = objectStack[objectStack.length - 1];
      ol.asserts.assert(feature.getId() !== undefined, 27); // Features must have an id set
      var featureType = context['featureType'];
      var featurePrefix = context['featurePrefix'];
      var featureNS = context['featureNS'];
      var typeName = ol.format.WFS.getTypeName_(featurePrefix, featureType);
      node.setAttribute('typeName', typeName);
      ol.xml.setAttributeNS(node, ol.format.WFS.XMLNS, 'xmlns:' + featurePrefix,
          featureNS);
      var fid = feature.getId();
      Eif (fid !== undefined) {
        var keys = feature.getKeys();
        var values = [];
        for (var i = 0, ii = keys.length; i < ii; i++) {
          var value = feature.get(keys[i]);
          if (value !== undefined) {
            values.push({name: keys[i], value: value});
          }
        }
        ol.xml.pushSerializeAndPop(/** @type {ol.XmlNodeStackItem} */ (
          {'gmlVersion': context['gmlVersion'], node: node,
            'hasZ': context['hasZ'], 'srsName': context['srsName']}),
        ol.format.WFS.TRANSACTION_SERIALIZERS_,
        ol.xml.makeSimpleNodeFactory('Property'), values,
        objectStack);
        ol.format.WFS.writeOgcFidFilter_(node, fid, objectStack);
      }
    };

    /**
     * @param {Node} node Node.
     * @param {Object} pair Property name and value.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeProperty_ = function(node, pair, objectStack) {
      var name = ol.xml.createElementNS(ol.format.WFS.WFSNS, 'Name');
      var context = objectStack[objectStack.length - 1];
      var gmlVersion = context['gmlVersion'];
      node.appendChild(name);
      ol.format.XSD.writeStringTextNode(name, pair.name);
      if (pair.value !== undefined && pair.value !== null) {
        var value = ol.xml.createElementNS(ol.format.WFS.WFSNS, 'Value');
        node.appendChild(value);
        if (pair.value instanceof ol.geom.Geometry) {
          if (gmlVersion === 2) {
            ol.format.GML2.prototype.writeGeometryElement(value,
                pair.value, objectStack);
          } else {
            ol.format.GML3.prototype.writeGeometryElement(value,
                pair.value, objectStack);
          }
        } else {
          ol.format.XSD.writeStringTextNode(value, pair.value);
        }
      }
    };

    /**
     * @param {Node} node Node.
     * @param {{vendorId: string, safeToIgnore: boolean, value: string}}
     *     nativeElement The native element.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeNative_ = function(node, nativeElement, objectStack) {
      Eif (nativeElement.vendorId) {
        node.setAttribute('vendorId', nativeElement.vendorId);
      }
      Eif (nativeElement.safeToIgnore !== undefined) {
        node.setAttribute('safeToIgnore', nativeElement.safeToIgnore);
      }
      Eif (nativeElement.value !== undefined) {
        ol.format.XSD.writeStringTextNode(node, nativeElement.value);
      }
    };

    /**
     * @type {Object.<string, Object.<string, ol.XmlSerializer>>}
     * @private
     */
    ol.format.WFS.TRANSACTION_SERIALIZERS_ = {
      'http://www.opengis.net/wfs': {
        'Insert': ol.xml.makeChildAppender(ol.format.WFS.writeFeature_),
        'Update': ol.xml.makeChildAppender(ol.format.WFS.writeUpdate_),
        'Delete': ol.xml.makeChildAppender(ol.format.WFS.writeDelete_),
        'Property': ol.xml.makeChildAppender(ol.format.WFS.writeProperty_),
        'Native': ol.xml.makeChildAppender(ol.format.WFS.writeNative_)
      }
    };

    /**
     * @param {Node} node Node.
     * @param {string} featureType Feature type.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeQuery_ = function(node, featureType, objectStack) {
      var context = /** @type {Object} */ (objectStack[objectStack.length - 1]);
      var featurePrefix = context['featurePrefix'];
      var featureNS = context['featureNS'];
      var propertyNames = context['propertyNames'];
      var srsName = context['srsName'];
      var typeName;
      // If feature prefix is not defined, we must not use the default prefix.
      if (featurePrefix) {
        typeName = ol.format.WFS.getTypeName_(featurePrefix, featureType);
      } else {
        typeName = featureType;
      }
      node.setAttribute('typeName', typeName);
      if (srsName) {
        node.setAttribute('srsName', srsName);
      }
      if (featureNS) {
        ol.xml.setAttributeNS(node, ol.format.WFS.XMLNS, 'xmlns:' + featurePrefix,
            featureNS);
      }
      var item = /** @type {ol.XmlNodeStackItem} */ (ol.obj.assign({}, context));
      item.node = node;
      ol.xml.pushSerializeAndPop(item,
          ol.format.WFS.QUERY_SERIALIZERS_,
          ol.xml.makeSimpleNodeFactory('PropertyName'), propertyNames,
          objectStack);
      var filter = context['filter'];
      if (filter) {
        var child = ol.xml.createElementNS(ol.format.WFS.OGCNS, 'Filter');
        node.appendChild(child);
        ol.format.WFS.writeFilterCondition_(child, filter, objectStack);
      }
    };

    /**
     * @param {Node} node Node.
     * @param {ol.format.filter.Filter} filter Filter.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeFilterCondition_ = function(node, filter, objectStack) {
      /** @type {ol.XmlNodeStackItem} */
      var item = {node: node};
      ol.xml.pushSerializeAndPop(item,
          ol.format.WFS.GETFEATURE_SERIALIZERS_,
          ol.xml.makeSimpleNodeFactory(filter.getTagName()),
          [filter], objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.format.filter.Bbox} filter Filter.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeBboxFilter_ = function(node, filter, objectStack) {
      var context = objectStack[objectStack.length - 1];
      context['srsName'] = filter.srsName;

      ol.format.WFS.writeOgcPropertyName_(node, filter.geometryName);
      ol.format.GML3.prototype.writeGeometryElement(node, filter.extent, objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.format.filter.Intersects} filter Filter.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeIntersectsFilter_ = function(node, filter, objectStack) {
      var context = objectStack[objectStack.length - 1];
      context['srsName'] = filter.srsName;

      ol.format.WFS.writeOgcPropertyName_(node, filter.geometryName);
      ol.format.GML3.prototype.writeGeometryElement(node, filter.geometry, objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.format.filter.Within} filter Filter.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeWithinFilter_ = function(node, filter, objectStack) {
      var context = objectStack[objectStack.length - 1];
      context['srsName'] = filter.srsName;

      ol.format.WFS.writeOgcPropertyName_(node, filter.geometryName);
      ol.format.GML3.prototype.writeGeometryElement(node, filter.geometry, objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.format.filter.During} filter Filter.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeDuringFilter_ = function(node, filter, objectStack) {

      var valueReference = ol.xml.createElementNS(ol.format.WFS.FESNS, 'ValueReference');
      ol.format.XSD.writeStringTextNode(valueReference, filter.propertyName);
      node.appendChild(valueReference);

      var timePeriod = ol.xml.createElementNS(ol.format.GMLBase.GMLNS, 'TimePeriod');

      node.appendChild(timePeriod);

      var begin = ol.xml.createElementNS(ol.format.GMLBase.GMLNS, 'begin');
      timePeriod.appendChild(begin);
      ol.format.WFS.writeTimeInstant_(begin, filter.begin);

      var end = ol.xml.createElementNS(ol.format.GMLBase.GMLNS, 'end');
      timePeriod.appendChild(end);
      ol.format.WFS.writeTimeInstant_(end, filter.end);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.format.filter.LogicalNary} filter Filter.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeLogicalFilter_ = function(node, filter, objectStack) {
      /** @type {ol.XmlNodeStackItem} */
      var item = {node: node};
      var conditions = filter.conditions;
      for (var i = 0, ii = conditions.length; i < ii; ++i) {
        var condition = conditions[i];
        ol.xml.pushSerializeAndPop(item,
            ol.format.WFS.GETFEATURE_SERIALIZERS_,
            ol.xml.makeSimpleNodeFactory(condition.getTagName()),
            [condition], objectStack);
      }
    };

    /**
     * @param {Node} node Node.
     * @param {ol.format.filter.Not} filter Filter.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeNotFilter_ = function(node, filter, objectStack) {
      /** @type {ol.XmlNodeStackItem} */
      var item = {node: node};
      var condition = filter.condition;
      ol.xml.pushSerializeAndPop(item,
          ol.format.WFS.GETFEATURE_SERIALIZERS_,
          ol.xml.makeSimpleNodeFactory(condition.getTagName()),
          [condition], objectStack);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.format.filter.ComparisonBinary} filter Filter.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeComparisonFilter_ = function(node, filter, objectStack) {
      if (filter.matchCase !== undefined) {
        node.setAttribute('matchCase', filter.matchCase.toString());
      }
      ol.format.WFS.writeOgcPropertyName_(node, filter.propertyName);
      ol.format.WFS.writeOgcLiteral_(node, '' + filter.expression);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.format.filter.IsNull} filter Filter.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeIsNullFilter_ = function(node, filter, objectStack) {
      ol.format.WFS.writeOgcPropertyName_(node, filter.propertyName);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.format.filter.IsBetween} filter Filter.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeIsBetweenFilter_ = function(node, filter, objectStack) {
      ol.format.WFS.writeOgcPropertyName_(node, filter.propertyName);

      var lowerBoundary = ol.xml.createElementNS(ol.format.WFS.OGCNS, 'LowerBoundary');
      node.appendChild(lowerBoundary);
      ol.format.WFS.writeOgcLiteral_(lowerBoundary, '' + filter.lowerBoundary);

      var upperBoundary = ol.xml.createElementNS(ol.format.WFS.OGCNS, 'UpperBoundary');
      node.appendChild(upperBoundary);
      ol.format.WFS.writeOgcLiteral_(upperBoundary, '' + filter.upperBoundary);
    };

    /**
     * @param {Node} node Node.
     * @param {ol.format.filter.IsLike} filter Filter.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeIsLikeFilter_ = function(node, filter, objectStack) {
      node.setAttribute('wildCard', filter.wildCard);
      node.setAttribute('singleChar', filter.singleChar);
      node.setAttribute('escapeChar', filter.escapeChar);
      if (filter.matchCase !== undefined) {
        node.setAttribute('matchCase', filter.matchCase.toString());
      }
      ol.format.WFS.writeOgcPropertyName_(node, filter.propertyName);
      ol.format.WFS.writeOgcLiteral_(node, '' + filter.pattern);
    };

    /**
     * @param {string} tagName Tag name.
     * @param {Node} node Node.
     * @param {string} value Value.
     * @private
     */
    ol.format.WFS.writeOgcExpression_ = function(tagName, node, value) {
      var property = ol.xml.createElementNS(ol.format.WFS.OGCNS, tagName);
      ol.format.XSD.writeStringTextNode(property, value);
      node.appendChild(property);
    };

    /**
     * @param {Node} node Node.
     * @param {string} value PropertyName value.
     * @private
     */
    ol.format.WFS.writeOgcPropertyName_ = function(node, value) {
      ol.format.WFS.writeOgcExpression_('PropertyName', node, value);
    };

    /**
     * @param {Node} node Node.
     * @param {string} value PropertyName value.
     * @private
     */
    ol.format.WFS.writeOgcLiteral_ = function(node, value) {
      ol.format.WFS.writeOgcExpression_('Literal', node, value);
    };

    /**
     * @param {Node} node Node.
     * @param {string} time PropertyName value.
     * @private
     */
    ol.format.WFS.writeTimeInstant_ = function(node, time) {
      var timeInstant = ol.xml.createElementNS(ol.format.GMLBase.GMLNS, 'TimeInstant');
      node.appendChild(timeInstant);

      var timePosition = ol.xml.createElementNS(ol.format.GMLBase.GMLNS, 'timePosition');
      timeInstant.appendChild(timePosition);
      ol.format.XSD.writeStringTextNode(timePosition, time);
    };

    /**
     * @type {Object.<string, Object.<string, ol.XmlSerializer>>}
     * @private
     */
    ol.format.WFS.GETFEATURE_SERIALIZERS_ = {
      'http://www.opengis.net/wfs': {
        'Query': ol.xml.makeChildAppender(ol.format.WFS.writeQuery_)
      },
      'http://www.opengis.net/ogc': {
        'During': ol.xml.makeChildAppender(ol.format.WFS.writeDuringFilter_),
        'And': ol.xml.makeChildAppender(ol.format.WFS.writeLogicalFilter_),
        'Or': ol.xml.makeChildAppender(ol.format.WFS.writeLogicalFilter_),
        'Not': ol.xml.makeChildAppender(ol.format.WFS.writeNotFilter_),
        'BBOX': ol.xml.makeChildAppender(ol.format.WFS.writeBboxFilter_),
        'Intersects': ol.xml.makeChildAppender(ol.format.WFS.writeIntersectsFilter_),
        'Within': ol.xml.makeChildAppender(ol.format.WFS.writeWithinFilter_),
        'PropertyIsEqualTo': ol.xml.makeChildAppender(ol.format.WFS.writeComparisonFilter_),
        'PropertyIsNotEqualTo': ol.xml.makeChildAppender(ol.format.WFS.writeComparisonFilter_),
        'PropertyIsLessThan': ol.xml.makeChildAppender(ol.format.WFS.writeComparisonFilter_),
        'PropertyIsLessThanOrEqualTo': ol.xml.makeChildAppender(ol.format.WFS.writeComparisonFilter_),
        'PropertyIsGreaterThan': ol.xml.makeChildAppender(ol.format.WFS.writeComparisonFilter_),
        'PropertyIsGreaterThanOrEqualTo': ol.xml.makeChildAppender(ol.format.WFS.writeComparisonFilter_),
        'PropertyIsNull': ol.xml.makeChildAppender(ol.format.WFS.writeIsNullFilter_),
        'PropertyIsBetween': ol.xml.makeChildAppender(ol.format.WFS.writeIsBetweenFilter_),
        'PropertyIsLike': ol.xml.makeChildAppender(ol.format.WFS.writeIsLikeFilter_)
      }
    };

    /**
     * Encode filter as WFS `Filter` and return the Node.
     *
     * @param {ol.format.filter.Filter} filter Filter.
     * @return {Node} Result.
     * @api
     */
    ol.format.WFS.writeFilter = function(filter) {
      var child = ol.xml.createElementNS(ol.format.WFS.OGCNS, 'Filter');
      ol.format.WFS.writeFilterCondition_(child, filter, []);
      return child;
    };

    /**
     * @param {Node} node Node.
     * @param {Array.<string>} featureTypes Feature types.
     * @param {Array.<*>} objectStack Node stack.
     * @private
     */
    ol.format.WFS.writeGetFeature_ = function(node, featureTypes, objectStack) {
      var context = /** @type {Object} */ (objectStack[objectStack.length - 1]);
      var item = /** @type {ol.XmlNodeStackItem} */ (ol.obj.assign({}, context));
      item.node = node;
      ol.xml.pushSerializeAndPop(item,
          ol.format.WFS.GETFEATURE_SERIALIZERS_,
          ol.xml.makeSimpleNodeFactory('Query'), featureTypes,
          objectStack);
    };

    /**
     * Encode format as WFS `GetFeature` and return the Node.
     *
     * @param {olx.format.WFSWriteGetFeatureOptions} options Options.
     * @return {Node} Result.
     * @api
     */
    ol.format.WFS.prototype.writeGetFeature = function(options) {
      var node = ol.xml.createElementNS(ol.format.WFS.WFSNS, 'GetFeature');
      node.setAttribute('service', 'WFS');
      node.setAttribute('version', '1.1.0');
      var filter;
      Eif (options) {
        Iif (options.handle) {
          node.setAttribute('handle', options.handle);
        }
        Iif (options.outputFormat) {
          node.setAttribute('outputFormat', options.outputFormat);
        }
        Iif (options.maxFeatures !== undefined) {
          node.setAttribute('maxFeatures', options.maxFeatures);
        }
        if (options.resultType) {
          node.setAttribute('resultType', options.resultType);
        }
        if (options.startIndex !== undefined) {
          node.setAttribute('startIndex', options.startIndex);
        }
        if (options.count !== undefined) {
          node.setAttribute('count', options.count);
        }
        filter = options.filter;
        if (options.bbox) {
          ol.asserts.assert(options.geometryName,
              12); // `options.geometryName` must also be provided when `options.bbox` is set
          var bbox = ol.format.filter.bbox(
              /** @type {string} */ (options.geometryName), options.bbox, options.srsName);
          Iif (filter) {
            // if bbox and filter are both set, combine the two into a single filter
            filter = ol.format.filter.and(filter, bbox);
          } else {
            filter = bbox;
          }
        }
      }
      ol.xml.setAttributeNS(node, 'http://www.w3.org/2001/XMLSchema-instance',
          'xsi:schemaLocation', this.schemaLocation_);
      /** @type {ol.XmlNodeStackItem} */
      var context = {
        node: node,
        'srsName': options.srsName,
        'featureNS': options.featureNS ? options.featureNS : this.featureNS_,
        'featurePrefix': options.featurePrefix,
        'geometryName': options.geometryName,
        'filter': filter,
        'propertyNames': options.propertyNames ? options.propertyNames : []
      };
      ol.asserts.assert(Array.isArray(options.featureTypes),
          11); // `options.featureTypes` should be an Array
      ol.format.WFS.writeGetFeature_(node, /** @type {!Array.<string>} */ (options.featureTypes), [context]);
      return node;
    };

    /**
     * Encode format as WFS `Transaction` and return the Node.
     *
     * @param {Array.<ol.Feature>} inserts The features to insert.
     * @param {Array.<ol.Feature>} updates The features to update.
     * @param {Array.<ol.Feature>} deletes The features to delete.
     * @param {olx.format.WFSWriteTransactionOptions} options Write options.
     * @return {Node} Result.
     * @api
     */
    ol.format.WFS.prototype.writeTransaction = function(inserts, updates, deletes,
        options) {
      var objectStack = [];
      var node = ol.xml.createElementNS(ol.format.WFS.WFSNS, 'Transaction');
      var version = options.version ?
        options.version : ol.format.WFS.DEFAULT_VERSION;
      var gmlVersion = version === '1.0.0' ? 2 : 3;
      node.setAttribute('service', 'WFS');
      node.setAttribute('version', version);
      var baseObj;
      /** @type {ol.XmlNodeStackItem} */
      var obj;
      Eif (options) {
        baseObj = options.gmlOptions ? options.gmlOptions : {};
        if (options.handle) {
          node.setAttribute('handle', options.handle);
        }
      }
      var schemaLocation = ol.format.WFS.SCHEMA_LOCATIONS[version];
      ol.xml.setAttributeNS(node, 'http://www.w3.org/2001/XMLSchema-instance',
          'xsi:schemaLocation', schemaLocation);
      var featurePrefix = options.featurePrefix ? options.featurePrefix : ol.format.WFS.FEATURE_PREFIX;
      if (inserts) {
        obj = {node: node, 'featureNS': options.featureNS,
          'featureType': options.featureType, 'featurePrefix': featurePrefix,
          'gmlVersion': gmlVersion, 'hasZ': options.hasZ, 'srsName': options.srsName};
        ol.obj.assign(obj, baseObj);
        ol.xml.pushSerializeAndPop(obj,
            ol.format.WFS.TRANSACTION_SERIALIZERS_,
            ol.xml.makeSimpleNodeFactory('Insert'), inserts,
            objectStack);
      }
      if (updates) {
        obj = {node: node, 'featureNS': options.featureNS,
          'featureType': options.featureType, 'featurePrefix': featurePrefix,
          'gmlVersion': gmlVersion, 'hasZ': options.hasZ, 'srsName': options.srsName};
        ol.obj.assign(obj, baseObj);
        ol.xml.pushSerializeAndPop(obj,
            ol.format.WFS.TRANSACTION_SERIALIZERS_,
            ol.xml.makeSimpleNodeFactory('Update'), updates,
            objectStack);
      }
      if (deletes) {
        ol.xml.pushSerializeAndPop({node: node, 'featureNS': options.featureNS,
          'featureType': options.featureType, 'featurePrefix': featurePrefix,
          'gmlVersion': gmlVersion, 'srsName': options.srsName},
        ol.format.WFS.TRANSACTION_SERIALIZERS_,
        ol.xml.makeSimpleNodeFactory('Delete'), deletes,
        objectStack);
      }
      if (options.nativeElements) {
        ol.xml.pushSerializeAndPop({node: node, 'featureNS': options.featureNS,
          'featureType': options.featureType, 'featurePrefix': featurePrefix,
          'gmlVersion': gmlVersion, 'srsName': options.srsName},
        ol.format.WFS.TRANSACTION_SERIALIZERS_,
        ol.xml.makeSimpleNodeFactory('Native'), options.nativeElements,
        objectStack);
      }
      return node;
    };

    /**
     * Read the projection from a WFS source.
     *
     * @function
     * @param {Document|Node|Object|string} source Source.
     * @return {?ol.proj.Projection} Projection.
     * @api
     */
    ol.format.WFS.prototype.readProjection;

    /**
     * @inheritDoc
     */
    ol.format.WFS.prototype.readProjectionFromDocument = function(doc) {
      for (var n = doc.firstChild; n; n = n.nextSibling) {
        if (n.nodeType == Node.ELEMENT_NODE) {
          return this.readProjectionFromNode(n);
        }
      }
      return null;
    };

    /**
     * @inheritDoc
     */
    ol.format.WFS.prototype.readProjectionFromNode = function(node) {
      if (node.firstElementChild &&
          node.firstElementChild.firstElementChild) {
        node = node.firstElementChild.firstElementChild;
        for (var n = node.firstElementChild; n; n = n.nextElementSibling) {
          if (!(n.childNodes.length === 0 ||
              (n.childNodes.length === 1 &&
              n.firstChild.nodeType === 3))) {
            var objectStack = [{}];
            this.gmlFormat_.readGeometryElement(n, objectStack);
            return ol.proj.get(objectStack.pop().srsName);
          }
        }
      }

      return null;
    };